<doc> Second lexer: recognize integer numbers.  </doc>
implementation class
Lexer: StreamLexer, ex2Defines

end;

implementation instance
Lexer
{
  <doc> The next character to read.  This is 0 if it is not set, -1
      when we have hit eof.  </doc>
  int nextch;

  <doc> The most recently read number.  </doc>
  public int number_value;
}

<doc> Return the next non-space character.  </doc>
int
  nextToken
{
  USASCIIEncoding e = [USASCIIEncoding shared];

  if (!nextch)
    nextch = [stream read];

  if (nextch == -1)
    return 0;

  while ([e isSpace byte (nextch)])
    {
      nextch = [stream read];
      if (nextch == -1)
	return 0;
    }

  if (nextch < '0' || nextch > '9')
    {
      = nextch;
      nextch = 0;
      return;
    }

  /* Do an integer (no bounds check).  */
  number_value = 0;
  do
    {
      number_value = 10 * number_value + (nextch - '0');
      nextch = [stream read];
    } while (nextch >= '0' && nextch <= '9');
  = NUMBER;
}

end;
